# Interface TwinfinityMeshStore

interface TwinfinityMeshStore {
HEAPF32: Float32Array;
HEAPU32: Uint32Array;
HEAPU8: Uint8Array;
wasmMemory: Memory;
_addGeometryBuffer(dataPtr: number, size: number): number;
_addGeometryBufferLegacy(
dataPtr: number,
size: number,
descriptorDataPtr: number,
descriptorCount: number,
): void;
_allocateMemory(size: number): number;
_cacheAllMeshes(): void;
_clearMeshCache(): void;
_deflate(
hashBytesPtr: number,
positionOutput: number,
indexOutput: number,
normalOutput: number,
countsOutput: number,
): boolean;
_freeMemory(ptr: number): void;
_getEdgeCount(hashBytesPtr: number): number;
_getGeometryBufferSize(): number;
_getMeshCacheMemoryUsage(): number;
_processMergeBatch(
mergeItemsPtr: number,
itemCount: number,
positionOutputPtr: number,
uvOutputPtr: number,
indexOutputPtr: number,
aabbOutputPtr: number,
initialVertexOffset: number,
countsOutput: number,
): boolean;
_readEdges(
hashBytesPtr: number,
edgeOutput: number,
maxOutputCount: number,
countsOutput: number,
): boolean;
_registerTransforms(entryDataPtr: number, count: number): void;
}

##### Index

### Properties

HEAPF32
HEAPU32
HEAPU8
wasmMemory

### Methods

_addGeometryBuffer
_addGeometryBufferLegacy
_allocateMemory
_cacheAllMeshes
_clearMeshCache
_deflate
_freeMemory
_getEdgeCount
_getGeometryBufferSize
_getMeshCacheMemoryUsage
_processMergeBatch
_readEdges
_registerTransforms

## Properties

### HEAPF32

HEAPF32: Float32Array

### HEAPU32

HEAPU32: Uint32Array

### HEAPU8

HEAPU8: Uint8Array

### wasmMemory

wasmMemory: Memory

## Methods

### _addGeometryBuffer

- _addGeometryBuffer(dataPtr: number, size: number): number

  #### Parameters

  - dataPtr: number
  - size: number

  #### Returns number

### _addGeometryBufferLegacy

- _addGeometryBufferLegacy(
  dataPtr: number,
  size: number,
  descriptorDataPtr: number,
  descriptorCount: number,
  ): void

  #### Parameters

  - dataPtr: number
  - size: number
  - descriptorDataPtr: number
  - descriptorCount: number

  #### Returns void

### _allocateMemory

- _allocateMemory(size: number): number

  #### Parameters

  - size: number

  #### Returns number

### _cacheAllMeshes

- _cacheAllMeshes(): void

  #### Returns void

### _clearMeshCache

- _clearMeshCache(): void

  #### Returns void

### _deflate

- _deflate(
  hashBytesPtr: number,
  positionOutput: number,
  indexOutput: number,
  normalOutput: number,
  countsOutput: number,
  ): boolean

  #### Parameters

  - hashBytesPtr: number
  - positionOutput: number
  - indexOutput: number
  - normalOutput: number
  - countsOutput: number

  #### Returns boolean

### _freeMemory

- _freeMemory(ptr: number): void

  #### Parameters

  - ptr: number

  #### Returns void

### _getEdgeCount

- _getEdgeCount(hashBytesPtr: number): number

  #### Parameters

  - hashBytesPtr: number

  #### Returns number

### _getGeometryBufferSize

- _getGeometryBufferSize(): number

  #### Returns number

### _getMeshCacheMemoryUsage

- _getMeshCacheMemoryUsage(): number

  #### Returns number

### _processMergeBatch

- _processMergeBatch(
  mergeItemsPtr: number,
  itemCount: number,
  positionOutputPtr: number,
  uvOutputPtr: number,
  indexOutputPtr: number,
  aabbOutputPtr: number,
  initialVertexOffset: number,
  countsOutput: number,
  ): boolean

  #### Parameters

  - mergeItemsPtr: number
  - itemCount: number
  - positionOutputPtr: number
  - uvOutputPtr: number
  - indexOutputPtr: number
  - aabbOutputPtr: number
  - initialVertexOffset: number
  - countsOutput: number

  #### Returns boolean

### _readEdges

- _readEdges(
  hashBytesPtr: number,
  edgeOutput: number,
  maxOutputCount: number,
  countsOutput: number,
  ): boolean

  #### Parameters

  - hashBytesPtr: number
  - edgeOutput: number
  - maxOutputCount: number
  - countsOutput: number

  #### Returns boolean

### _registerTransforms

- _registerTransforms(entryDataPtr: number, count: number): void

  #### Parameters

  - entryDataPtr: number
  - count: number

  #### Returns void